/**
 * This module defines a parser for the 2bit file format.
 * See http://genome.ucsc.edu/FAQ/FAQformat.html#format7
 * 
 */
'use strict';

/* exported Q, ContigInterval, RemoteRequest */Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}var _q = require(
'q');var _q2 = _interopRequireDefault(_q);var _ContigInterval = require(
'../ContigInterval');var _ContigInterval2 = _interopRequireDefault(_ContigInterval);var _RemoteRequest = require(
'../RemoteRequest');var 






Sequence = (function () {



  function Sequence(remoteRequest, contigList) {_classCallCheck(this, Sequence);
    this.remoteRequest = remoteRequest;
    this.contigList = contigList;}


  // Returns a list of contig names.
  _createClass(Sequence, [{ key: 'getContigNames', value: function getContigNames() {
      return this.contigList.map(function (seq) {return seq.name;});}


    // Returns a list of contig names.
  }, { key: 'getContigs', value: function getContigs() {
      return this.contigList;}


    /**
     * Returns the base pairs for contig:start-stop.
     * The range is inclusive and zero-based.
     * Returns empty string if no data is available on this range.
     */ }, { key: 'getFeaturesInRange', value: 
    function getFeaturesInRange(range) {
      var start = range.start();
      var stop = range.stop();
      if (start > stop) {
        throw 'Requested a range with start > stop (' + start + ', ' + stop + ')';}

      return this.remoteRequest.get(range.contig, start, stop).then(function (e) {
        return e.response;});} }]);return Sequence;})();





module.exports = Sequence;